//1000,"rozlist.sci","rozlist.sci",2.24,SYSTEM
//Copyright (c) Sage sp. z o.o.. Wszelkie prawa zastrzeone.

// Dla wersji 2009 i wyszych.
// Nie bya testowana na 2008, cho jest pisana tak, by dziaaa.
// Raporty 2008 powinny zdefiniowa dispatche XROWSDATA i XROWSPARAM przed zainkludowaniem.

#ifndef __ROZLIST_SCI__
#define __ROZLIST_SCI__

#include "debug.sci"
#include "konto.sci"

// czy raport wykonywany z okna opartego na XROWS (2009)
bool sub rozlistIsX()
	rozlistIsX = XROWSDATA && XROWSPARAM
endsub

bool rozList_bRozliczone, rozList_bNierozWsz, rozList_bNierozTerm, rozList_bNierozPrze, rozList_bBezDaty, rozList_bWalutaSel, rozList_bWszystkie, rozList_bSelTermin, rozList_bSelStanNa, rozList_bOdKwoty, rozList_bDoKwoty, rozList_bRzeczywiste, rozList_bPotencjalne, rozList_bWaluty
long rozList_iSelOkres, rozList_iKolWyswietlana, rozList_iWho
string rozList_sKthNumer, rozList_sKthSkr, rozList_sKonto( 6 ), rozList_sOdDaty, rozList_sDoDaty, rozList_sWaluta
float rozList_fOdKwoty, rozList_fDoKwoty

// wartoci dla rozList_iKolWyswietlana, jak w rozdata.h
#define KW_NRKONTA 0
#define KW_KONTRAKT 1
#define KW_OPISZAPISU 2

// typy danych, oparte na numerach schematw, jak w roz.tbl
#define ROZLIST_TD_ZL 0 // w zotwkach
#define ROZLIST_TD_WAL 1 // w walucie
#define ROZLIST_TD_EMPTY 2 // fake row -  Brak elementw speniajcych kryteria
#define ROZLIST_TD_KURSYWA_ZL 4 // transakcje potencjalne z
#define ROZLIST_TD_KURSYWA_WAL 5 // transakcje potencjalne waluta

bool sub rozlistIsSchemaWal( int a_td )
	if ROZLIST_TD_WAL == a_td || ROZLIST_TD_KURSYWA_WAL == a_td then rozlistIsSchemaWal = true
endsub

bool sub rozlistIsSchemaZl( int a_td )
	if ROZLIST_TD_ZL == a_td || ROZLIST_TD_KURSYWA_ZL == a_td then rozlistIsSchemaZl = true
endsub

bool sub rozlistIsSchemaPot( int a_td )
	if ROZLIST_TD_KURSYWA_ZL == a_td || ROZLIST_TD_KURSYWA_WAL == a_td then rozlistIsSchemaPot = true
endsub

bool sub rozlistIsSchemaRzecz( int a_td )
	if ROZLIST_TD_ZL == a_td || ROZLIST_TD_WAL == a_td then rozlistIsSchemaRzecz = true
endsub

PRIVATE int ROZLIST_MINPARAMCOUNT
if ISFORTE then
	ROZLIST_MINPARAMCOUNT = 44
else
	ROZLIST_MINPARAMCOUNT = 29
endif

// obiekty biznesowe przechowujce kryteria listy rozrachunkw i rozrachunki
dispatch rozList_xParams
dispatch rozList_xRoz

// w rzeczy samej skrt to jest tylko dla kontrahenta
PRIVATE string sub rozlistGetSkrot( int a_baza, long a_poz )
	BTERRORTYPE ePodm
	BASEHANDLE bPodm
	string sPole
	select case a_baza
	case FKUTIL_KARTID_KTH
		bPodm = dbOpen( DN_KTH, true )
		sPole = "skrot"
	case FKUTIL_KARTID_PRAC
		bPodm = dbOpen( DN_PRAC, true )
		sPole = "nazwisko"
	case FKUTIL_KARTID_URZ
		bPodm = dbOpen( DN_URZ, true )
		sPole = "nazwa"
	endselect
	if bPodm then
		setKey( bPodm, "pozycja" )
		setKeySeg( bPodm, "pozycja", a_poz )
		ePodm = getRec( bPodm, EQ )
		if !ePodm then rozlistGetSkrot = getField( bPodm, sPole )
		dbClose( bPodm )
	endif
endsub

PRIVATE mapValue rozlist_mvItem // z argumentu danychOkna do indeksu w x-rowsie
rozlist_mvItem.type( long )

PRIVATE mapValue rozlist_mvIdx // odwrotnie do rozlist_mvItem
rozlist_mvIdx.type( long )

// ustawia by rozlistGetId nie ustawiao rozlist_do ani rozlist_typ (czyli nie parsowao)
bool rozlist_bDontParse

#define ROZLIST_ALLWALS "wszystkie"
#define ROZLIST_WALZL "z"

// czy wydruki maj by w walucie czy w zotwkach
// jest to raczej wybr w filtrze waluty, uytkownik moe zayczy sobie wydruku w zotwkach dla transakcji walutowych
// w 2008 zaleao to od czekboxa
// w 2009 zaley od wyboru na listboxie
bool sub rozlistWydrukWWalucie()
	if arg6 != ROZLIST_ALLWALS then rozlistWydrukWWalucie = true
endsub

bool sub rozlistWyfiltrowanoObce()
	if rozlistWydrukWWalucie() && arg6 != ROZLIST_WALZL then rozlistWyfiltrowanoObce = true
endsub

bool sub rozlistWyfiltrowanoZL()
	if arg6 == ROZLIST_WALZL then rozlistWyfiltrowanoZL = true
endsub

// kryteria listy rozrachunkw
// zgodnie z SRozKryt::SaveToBuf, CRozData::PrintFromGroup
int sub rozlistInit()
	rozlist_bDontParse = false

	rozlist_mvItem.clear()
	rozlist_mvIdx.clear()

	rozList_bRozliczone = rozList_bNierozWsz = rozList_bNierozTerm = rozList_bNierozPrze = rozList_bBezDaty = rozList_bWalutaSel = rozList_bWszystkie = rozList_bSelTermin = rozList_bSelStanNa = rozList_bOdKwoty = rozList_bDoKwoty = rozList_bRzeczywiste = rozList_bPotencjalne = rozList_bWaluty = false
	rozList_iSelOkres = rozList_iKolWyswietlana = 0
	rozList_sKthNumer = rozList_sKthSkr = rozList_sWaluta = rozList_sOdDaty = rozList_sDoDaty = rozList_sKonto( 1 ) = rozList_sKonto( 2 ) = rozList_sKonto( 3 ) = rozList_sKonto( 4 ) = rozList_sKonto( 5 ) = rozList_sKonto( 6 ) = ""
	rozList_fOdKwoty = rozList_fDoKwoty = 0.0

	rexParser rp
	int i, rpc
	infoKonta ik
	int iRok, iMc

	if !rozlistIsX() then
		rp.init( "," )
		rpc = rp.parse( arg5 )
		// Ponisze wyjcie zadziaa w przypadku gdy XROWS* s atrapami,
		// bo raport nie jest wykonywany z okna rozrachunkw (np. notaods.sc, patrz komentarz tame).
		if ROZLIST_MINPARAMCOUNT > rpc then exit
		if ISFORTE then
			rozList_iKolWyswietlana = val( rp.get( 40 ) )
			rozList_bWaluty = !!val( rp.get( 41 ) )
			rozList_bRzeczywiste = !!val( rp.get( 42 ) )
			rozList_bPotencjalne = !!val( rp.get( 43 ) )
		else
			rozList_iKolWyswietlana = val( rp.get( 27 ) )
			rozList_bWaluty = !!val( rp.get( 28 ) )
			rozList_bRzeczywiste = true
		endif
		rozList_bRozliczone = !!val( rp.get( 1 ) )
		rozList_bNierozWsz = !!val( rp.get( 2 ) )
		rozList_bNierozTerm = !!val( rp.get( 3 ) )
		rozList_bNierozPrze = !!val( rp.get( 4 ) )
		rozList_sKthNumer = rp.get( 5 )
		rozList_sKthSkr = rp.get( 6 )
	
		// doczytanie skrtu z przecinkiem
		if ROZLIST_MINPARAMCOUNT < rpc && !rozList_sKthSkr && val( rozList_sKthNumer ) then
			rozList_sKthSkr = rozlistGetSkrot( rozList_iWho = val( rp.get( ROZLIST_MINPARAMCOUNT ) ), val( rozList_sKthNumer ) )
		endif
	
		rozList_sKonto( 1 ) = rp.get( 7 )
		rozList_sKonto( 2 ) = rp.get( 8 )
		rozList_sKonto( 3 ) = rp.get( 9 )
		rozList_sKonto( 4 ) = rp.get( 10 )
		rozList_sKonto( 5 ) = rp.get( 11 )
		rozList_sKonto( 6 ) = rp.get( 12 )
		rozList_sOdDaty = rp.get( 14 )
		rozList_sDoDaty = rp.get( 15 )
		rozList_bBezDaty = !!val( rp.get( 16 ) )
		rozList_fOdKwoty = val( rp.get( 17 ) )
		rozList_fDoKwoty = val( rp.get( 18 ) )
		rozList_bWalutaSel = !!val( rp.get( 19 ) )
		rozList_sWaluta = rp.get( 20 )
		rozList_bWszystkie = !!val( rp.get( 21 ) )
		rozList_bSelTermin = !!val( rp.get( 22 ) )
		rozList_bSelStanNa = !!val( rp.get( 23 ) )
		rozList_iSelOkres = val( rp.get( 24 ) )
		rozList_bOdKwoty = !!val( rp.get( 25 ) )
		rozList_bDoKwoty = !!val( rp.get( 26 ) )
		// dla forte tu nowe pola
	else
		// do wersji 2008 wcznie, arg5 zawierao parametry
		// w 2009, trzeba wczyta parametry nie z arg5, a z XROWSPARAM
		// TODO? przenie ustawianie arg1..arg4,arg6 do C++, wtedy mniej zmian w SBC
		rozList_xRoz = XROWSDATA
		rozList_xParams = XROWSPARAM

		// wypeniam arg? i rozList_* tak jak w 2008
		select case rozList_xParams.stan
		case 1
			rozList_bNierozPrze = true
		case 2
			rozList_bNierozTerm = true
		case 3
			rozList_bNierozWsz = true
		case 4
			rozList_bRozliczone = true
		case else
			rozList_bWszystkie = true
		endselect

		rozlist_iWho = rozList_xParams.podmiot

		//w 2008 nie byo podmiotu od .. do, tylko jeden wybrany
		if rozList_xParams.czyPodmiotNa && rozList_xParams.podmiotNa then
			rozList_sKthNumer = long2string( rozList_xParams.podmiotNa )
			rozList_sKthSkr = rozlistGetSkrot( rozList_xParams.podmiot, rozList_xParams.podmiotNa )
		else
			rozList_sKthNumer = long2string( 0 )
		endif

		i = kontoParse( rozList_xParams.konto, ik )
		while i
			rozList_sKonto( i ) = long2string( ik.konto( i ) )
			i -= 1
		wend

		select case lcase( rozList_xParams.stanTerminTxt )
		case "pierwszej transakcji"
			rozList_sOdDaty = rozList_xParams.stanTerminTxt // bug 3258
		case else
			rozList_sOdDaty = rozList_xParams.stanAktualnyNa
		endselect
		rozList_sDoDaty = rozList_xParams.stanAktualnyDo

		if !rozList_xParams.czyKwotaNa && rozList_xParams.kwotaNa then
			rozList_bOdKwoty = true
			rozList_fOdKwoty = rozList_xParams.kwotaNa
		endif
		if rozList_xParams.kwotaDo then
			rozList_bDoKwoty = true
			rozList_fDoKwoty = rozList_xParams.kwotaDo
		endif

		select case rozList_xRoz.waluty.ex
		case -1 // obce
				arg6 = "obce"
		case 0
			if "z" == rozList_xRoz.waluty.kod then
				// zotwki
				rozList_bWalutaSel = true
				arg6 = rozList_xRoz.waluty.kod
			else
				// wszystkie
				arg6 = ROZLIST_ALLWALS
			endif
		case else // konkretna waluta
			rozList_bWalutaSel = true
			arg6 = rozList_sWaluta = rozList_xRoz.waluty.kod
		endselect

		rozList_bSelTermin = false // ?
		rozList_iSelOkres = 0 // ?

		rozList_iKolWyswietlana = KW_NRKONTA // tu niejednoznaczno bo w 2009 wszystkie kolumny s dostpne przez xrowsy

		// ustawia w zalenoci od widocznoi kolumny "Waluta" ?
		rozList_bWaluty = true

		rozList_bRzeczywiste = !!rozList_xParams.rzeczywiste
		if ISFORTE then rozList_bPotencjalne = !!rozList_xParams.potencjalne

		// podmioty
		select case rozList_xParams.podmiot
		case FKUTIL_KARTID_PRAC, FKUTIL_KARTID_KTH, FKUTIL_KARTID_RACH, FKUTIL_KARTID_URZ
			i = rozList_xParams.podmiot
		case 5
			i = 0
		case else
			i = -1
		endselect
		arg1 = int2string( i )

		// nalenoci, zobowizania, razem
		select case rozList_xParams.typ
		case 1 // N
			i = 0
		case 2 // Z
			i = 1
		case else // Razem
			i = 3
		endselect
		arg2 = int2string( i )

		// sort, pki co, nie zawiera waciwej informacji
		// ale te nie wyglda na uywany ...
		// TODO przemapowa na te wartoci co w 2008?
		// w 2008 zawsze rosnco
		if arg3 = rozList_xParams.sort then
			if rozList_xParams.sortASC then
				arg3 += " (rosnco)"
			else
				arg3 += " (malejco)"
			endif
		endif
		
		// stan na dzie
		if rozList_xParams.stanTermin then
			rozList_bSelStanNa = true
		else
			rozList_bSelStanNa = false
		endif

		select case lcase( rozList_xParams.stanNaOkresTxt )
		case "pocztek roku" // bug 3257: tak jak w 2008, dzie przed pocztkiem roku
			if indeksRoku() > 0 then
				dateutilRok( -1 + indeksRoku() )
				arg4 = dateutilRROK.sKoniec
			else
				dateutilRok( 0 )
				iRok = dateutilRokZDaty( dateutilRROK.poczatek )
				iMc = dateutilMiesiacZDaty( dateutilRROK.poczatek )
				iMc -= 1
				if !iMc then
					iMc = 12
					iRok -= 1
				endif
				arg4 = dateutilDataRMD( iRok, iMc, dateutilOstatniDzien( iRok, iMc ) )
			endif
		case else
			arg4 = rozList_xParams.stanNaDzien
		endselect

		//czekbox
		rozList_bBezDaty = !!rozList_xParams.bezTerminu

		//arg5 nie odtwarzam, zakadam e cay dostp w raportach bdzie przez rozList_*
	endif

	select case rozList_iKolWyswietlana
	case KW_NRKONTA
	case KW_OPISZAPISU
	case else
		rozList_iKolWyswietlana = KW_NRKONTA
	endselect
endsub

rozlistInit()

// synchronizowa z roz.tbl
// UWAGA: rnice w zawartoci ROZLIST_COL_KWOTA* w porwnaniu z 2008 ...
#define ROZLIST_COL_ERROR			1
#define ROZLIST_COL_ZNACZNIK		2
#define ROZLIST_COL_NOTATKA 		3
#define ROZLIST_COL_TERMIN			4
#define ROZLIST_COL_STAN			5
#define ROZLIST_COL_KWOTA			6
#define ROZLIST_COL_WALUTA			7
#define ROZLIST_COL_KONTRSYMB		8
#define ROZLIST_COL_KONTRNR			9
#define ROZLIST_COL_KONTR			10
#define ROZLIST_COL_DOKUMENT		11
#define ROZLIST_COL_DATA			12
#define ROZLIST_COL_NRWYSWIETLANY	13
#define ROZLIST_COL_TRANS			14
#define ROZLIST_COL_KWOTAW			15
#define ROZLIST_COL_RACHID			16
#define ROZLIST_COL_DNIPOTERMINIE	17 // nie ma w Premium
#define ROZLIST_COL_NROZBMP			18 // nie ma w Premium
#define ROZLIST_COL_KONTO			19 // !!! nie ma w Premium
#define ROZLIST_COL_ZNPODM			20
#define ROZLIST__LASTCOL			20

// typ danych ostatnio pobranego wiersza
PRIVATE int rozlist_typ

// czy biecy wiersz odpowiada transakcji potencjalnej
bool sub rozlistIsRowPot()
	rozlistIsRowPot = rozlistIsSchemaPot( rozlist_typ )
endsub

// czy biecy wiersz odpowiada transakcji rzeczywistej
bool sub rozlistIsRowRzecz()
	rozlistIsRowRzecz = rozlistIsSchemaRzecz( rozlist_typ )
endsub

// czy dane okna biecego wiersza zawieraj dan kolumn
bool sub rozlistColExists( int a_col )
	bool bRes = true
	select case a_col
	case ROZLIST_COL_KONTO, ROZLIST_COL_NROZBMP, ROZLIST_COL_DNIPOTERMINIE
		bRes = ISFORTE
	endselect
	rozlistColExists = bRes
endsub

// zwraca index do rozlist_rp.get()
// uwaga, nierwnoci na nieostre, bo gdy ostatnia kolumna opcjonalna,
// to le wyliczaa si warto dla rozlistGetColCount()
PRIVATE int sub rozlistGetCol( int a_col )
	if !rozlistColExists( a_col ) then exit // zwracam 0
	// jadziem od koca
	if a_col >= ROZLIST_COL_KONTO && !rozlistColExists( ROZLIST_COL_KONTO ) then a_col-=1 // !!!
	if a_col >= ROZLIST_COL_NROZBMP && !rozlistColExists( ROZLIST_COL_NROZBMP ) then a_col-=1
	if a_col >= ROZLIST_COL_DNIPOTERMINIE && !rozlistColExists( ROZLIST_COL_DNIPOTERMINIE ) then a_col-=1
	rozlistGetCol = a_col
endsub

// zwraca ilo kolumn zwracan przez DaneOkna
// woa po rozlistParse
PRIVATE int sub rozlistGetColCount()
	rozlistGetColCount = 1 + rozlistGetCol( ROZLIST__LASTCOL ) // nr ostatniej kolumny, +1 bo DaneOkna kocz si \t ...
endsub

PRIVATE rexParser rozlist_rp
rozlist_rp.init( "\t" )

// buduje dane okna a la 2008 na podstawie rozList_xRoz( a_item )
// uywajc tej funkcji mona zminimalizowa zmiany w raportach
// w kwotach: kropki na spacje, jak w 2008
string sub rozlistBuildDaneOkna( long a_item )
	int col, i
	string s
	if ( col = rozlistGetCol( ROZLIST_COL_ERROR ) ) then rozlist_rp.set( -col, "0" ) // ? - nieuywane w obecnych raportach

	// na rdach 2008.03.07, przychodzi o 135 za mao
	if ( col = rozlistGetCol( ROZLIST_COL_ZNACZNIK ) ) then
		i = rozList_xRoz.item( a_item ).znacznik
		rozlist_rp.set( -col, long2string( i ) )
	endif

	if ( col = rozlistGetCol( ROZLIST_COL_NOTATKA ) ) then rozlist_rp.set( -col, long2string( rozList_xRoz.item( a_item ).notatka ) )
	if ( col = rozlistGetCol( ROZLIST_COL_TERMIN ) ) then rozlist_rp.set( -col, rozList_xRoz.item( a_item ).termin )
	if ( col = rozlistGetCol( ROZLIST_COL_STAN ) ) then rozlist_rp.set( -col, rozList_xRoz.item( a_item ).stan )
	if ( col = rozlistGetCol( ROZLIST_COL_KWOTA ) ) then
		buf = kwota( rozList_xRoz.item( a_item ).kwota )
		arg ".", " "
		replace arg
		delete arg
		rozlist_rp.set( -col, buf )
	endif
	if ( col = rozlistGetCol( ROZLIST_COL_WALUTA ) ) then rozlist_rp.set( -col, rozList_xRoz.item( a_item ).waluta )
	if ( col = rozlistGetCol( ROZLIST_COL_KONTRSYMB ) ) then rozlist_rp.set( -col, fkutilBaza2Typkart( rozList_xRoz.item( a_item ).baza ) )
	if ( col = rozlistGetCol( ROZLIST_COL_KONTRNR ) ) then rozlist_rp.set( -col, long2string( rozList_xRoz.item( a_item ).kontrahent ) )
	if ( col = rozlistGetCol( ROZLIST_COL_KONTR ) ) then rozlist_rp.set( -col, rozList_xRoz.item( a_item ).podmiot )
	if ( col = rozlistGetCol( ROZLIST_COL_DOKUMENT ) ) then rozlist_rp.set( -col, ( using "%s.  %s", rozList_xRoz.item( a_item ).numerEwi, rozList_xRoz.item( a_item ).numerDk ) ) // dla zgodnoci z 2008
	if ( col = rozlistGetCol( ROZLIST_COL_DATA ) ) then rozlist_rp.set( -col, rozList_xRoz.item( a_item ).data )
	// w 2008 dostpne przez daneOkna byo tylko jedno pole (jak poniej) ...
	// UWAGA: logika istniejcych raportw zaley od rozList_iKolWyswietlana
	// w 2009 wszystkie pola mam, jak wida, dostpne przez BRozrachunki ...
	select case rozList_iKolWyswietlana
	case KW_NRKONTA
		s = rozList_xRoz.item( a_item ).konto
	case KW_KONTRAKT
		s = rozList_xRoz.item( a_item ).kontrakt
	case KW_OPISZAPISU
		s = rozList_xRoz.item( a_item ).opis
	endselect
	if ( col = rozlistGetCol( ROZLIST_COL_NRWYSWIETLANY ) ) then rozlist_rp.set( -col, s )
	if ( col = rozlistGetCol( ROZLIST_COL_TRANS ) ) then rozlist_rp.set( -col, long2string( rozList_xRoz.item( a_item ).id ) )
	if ( col = rozlistGetCol( ROZLIST_COL_KWOTAW ) ) then
		buf = kwota( rozList_xRoz.item( a_item ).kwotaWal )
		arg ".", " "
		replace arg
		delete arg
		rozlist_rp.set( -col, buf )
	endif
	if ( col = rozlistGetCol( ROZLIST_COL_RACHID ) ) then rozlist_rp.set( -col, long2string( rozList_xRoz.item( a_item ).rachunek ) )
	if ( col = rozlistGetCol( ROZLIST_COL_DNIPOTERMINIE ) ) then rozlist_rp.set( -col, long2string( rozList_xRoz.item( a_item ).dni ) )
	if ( col = rozlistGetCol( ROZLIST_COL_NROZBMP ) ) then rozlist_rp.set( -col, long2string( rozList_xRoz.item( a_item ).wymagane ) )
	if ( col = rozlistGetCol( ROZLIST_COL_KONTO ) ) then rozlist_rp.set( -col, rozList_xRoz.item( a_item ).konto )

	if ( col = rozlistGetCol( ROZLIST_COL_ZNPODM ) ) then
		i = rozList_xRoz.item( a_item ).znacznikKTH
		rozlist_rp.set( -col, long2string( i ) )
	endif

	if ( col = rozlistGetColCount() ) then
		rozlist_rp.set( -col, "" ) // terminator
	endif
	rozlistBuildDaneOkna = rozlist_rp.getAll()
endsub

// parsuje buf, ktre ma pochodzi z DaneOkna listy rozrachunkw
// a_typ jest to warto zwrcona przez typDanych
// zwraca true iff sukces
bool sub rozlistParse( int a_typ )
	rozlist_typ = a_typ
	if rozlistGetColCount() == rozlist_rp.parse( buf ) then
		rozlistParse = true
	endif
endsub

// zwraca warto z kolumny a_col
// a_col = ROZLIST_COL_*
// woa po rozlistParse
string sub rozlistGetVal( int a_col )
	rozlistGetVal = rozlist_rp.get( rozlistGetCol( a_col ) )
endsub

// czy biecy wiersz zawiera symbol waluty
// uwaga sprawdzi jak to jest woane
bool sub rozlistRowHasWal()
	rozlistRowHasWal = ( "z" != rozlistGetVal( ROZLIST_COL_WALUTA ) )
endsub

// czy biecy wiersz nie zawiera symbolu waluty
// uwaga sprawdzi jak to jest woane
bool sub rozlistRowHasZl()
	rozlistRowHasZl = ( "z" == rozlistGetVal( ROZLIST_COL_WALUTA ) )
endsub

// sprawdza czy w oknie s potencjalne, wypisuje komunikat jeli s
bool sub rozlistCzyPotencjalne()
	if rozList_bPotencjalne then
		message using "Raport \"%s\" mona wykona tylko dla istniejcych transakcji.", getReportName()
	else
		rozlistCzyPotencjalne = true
	endif
endsub

// zamienia nr bitmapy R na standardow reprezentacj tekstow
// podobny kod jest w systow_RtoStr
string sub rozlistRtoStr( long a_bmpId )
	select case a_bmpId
	case 131
		rozlistRtoStr = "?"
	case 132
		rozlistRtoStr = "!"
	case 133
		rozlistRtoStr = "!?"
	endselect
endsub

PRIVATE long rozlist_pos, rozlist_posmax, rozlist_nextidx
PRIVATE string rozlist_do

PRIVATE void sub rozlistDOfromItem( long a_item )
	if "z" == rozList_xRoz.item( a_item ).waluta then
		if rozList_xRoz.item( a_item ).potencjalna then
			rozlist_typ = ROZLIST_TD_KURSYWA_ZL
		else
			rozlist_typ = ROZLIST_TD_ZL
		endif
	else
		if rozList_xRoz.item( a_item ).potencjalna then
			rozlist_typ = ROZLIST_TD_KURSYWA_WAL
		else
			rozlist_typ = ROZLIST_TD_WAL
		endif
	endif
	rozlist_do = rozlistBuildDaneOkna( a_item )
endsub

// w trybie xrows bedzie dziaao tylko dla kolejno przekazywanych a_i
string sub rozlistDaneOkna( long a_i )
	string s
	if rozlistIsX() then
		if rozlist_mvItem.index( s = long2string( a_i ) ) then
			// ju zmapowane
			rozlistDOfromItem( rozlist_mvItem.get( s ) )
			rozlistDaneOkna = rozlist_do
		else
			if rozlist_nextidx == a_i then
				rozlistDaneOkna = rozlist_do // parsowanie byo w rozlistGetId
			else
				error "rozlistDaneOkna" // naley woa wg kolejnych indeksw
			endif
		endif
	else
		rozlistDaneOkna = daneOkna( a_i )
	endif	
endsub

// Rozszerzenie getId na przypadek xrowsw.
long sub rozlistGetId( int a_mode )
	long nextId
	if rozlistIsX() then
		// w rozList_xRoz s te itemy ktre trzeba opuci !
		if FS == a_mode then
			rozlist_pos = 0
			rozlist_posmax = rozList_xRoz.count()
			rozlist_nextidx = 0
			//niepotrzebne, raport cay czas z jednego okna
			//rozlist_mvItem.clear()
		endif
		nextId = getId( a_mode ) // tego zaraz bd szuka, bo musz zwrci id
		rozlist_nextidx += 1
		rozlist_pos += 1 // ustawi si na nastpnym

		while rozlist_pos <= rozlist_posmax && nextId != rozList_xRoz.item( rozlist_pos ).id
			// jeli tu wejdzie to znak e BRozrachunki zawieraj wicej itemw ni wybrane do zestawienia
			// a wic np gdy dla biecego, a biecy nie jest pierwszym.
			// Ta sytuacja powoduje, e nie ma ju dowolnoci w siganiu po "dane okna",
			// rozlistDaneOkna musi by woane z kolejnymi argumentami, na przemian z wywoaniami rozlistGetId.
			// Dopiero po wywoaniu rozlistDaneOkna dla wszystkich rekordw,
			// mona woa je wyrywkowo ...
			rozlist_pos += 1
		wend

		if rozlist_pos <= rozlist_posmax then
			if rozlist_bDontParse then
				// nic nie parsujemy, bo ma by szybko (bug 3211)
				rozlistGetId = nextId
				rozlist_mvItem.set( long2string( rozlist_nextidx ), rozlist_pos )
				rozlist_mvIdx.set( long2string( rozlist_pos ), rozlist_nextidx )
			else
				rozlistDOfromItem( rozlist_pos ) // ustawia rozlist_do
				buf = rozlist_do
				if rozlistParse( rozlist_typ ) then
					rozlistGetId = nextId
					rozlist_mvItem.set( long2string( rozlist_nextidx ), rozlist_pos )
					rozlist_mvIdx.set( long2string( rozlist_pos ), rozlist_nextidx )
				else
					rozlist_do = ""
				endif
			endif
		endif
	else
		if FS == a_mode then
			rozlist_nextidx = 0
		endif
		rozlist_nextidx += 1
		rozlistGetId = getId( a_mode )
		rozlist_typ = typDanych( rozlist_nextidx )
	endif	
endsub

string sub rozlistWarnApproxPLNamt()
	string s
	s += "Dla rozrachunkw nierozliczonych raport prezentuje przyblion warto stanu rozrachunkw w zotwkach, wyliczon po aktualnym kursie transakcji.\n"
	s += "Ewentualne rnice midzy stanem rozrachunkw a saldem rozlicze wynikaj z zaokrgle zastosowanych przy wyliczaniu rnic kursowych."
	rozlistWarnApproxPLNamt = s
endsub

#endif
